//------------------------------------------------------------------------------
// <copyright file="ButtonType.cs" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
//------------------------------------------------------------------------------

namespace System.Web.UI.WebControls {


    /// <devdoc>
    /// Specifies the types of buttons we can render.
    /// </devdoc>
    public enum ButtonType {


        /// <devdoc>
        /// A plain button, like the Button WebControl.
        /// </devdoc>
        Button = 0,


        /// <devdoc>
        /// An image button, like the ImageButton WebControl.
        /// </devdoc>
        Image = 1,


        /// <devdoc>
        /// A link button, like the LinkButton WebControl.
        /// </devdoc>
        Link = 2
    }

}
