//------------------------------------------------------------------------------
// <copyright file="FirstDayOfWeek.cs" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>                                                                
//------------------------------------------------------------------------------

namespace System.Web.UI.WebControls {
    

    /// <devdoc>
    ///    <para>
    ///       Specifies the first day of the week.
    ///    </para>
    /// </devdoc>
    public enum FirstDayOfWeek {

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Sunday.
        ///    </para>
        /// </devdoc>
        Sunday = 0,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Monday.
        ///    </para>
        /// </devdoc>
        Monday = 1,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Tuesday.
        ///    </para>
        /// </devdoc>
        Tuesday = 2,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Wednesday.
        ///    </para>
        /// </devdoc>
        Wednesday = 3,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Thursday.
        ///    </para>
        /// </devdoc>
        Thursday = 4,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Friday.
        ///    </para>
        /// </devdoc>
        Friday = 5,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is Saturday.
        ///    </para>
        /// </devdoc>
        Saturday = 6,

        /// <devdoc>
        ///    <para>
        ///       The first day if the week is the system specified day.
        ///    </para>
        /// </devdoc>
        Default = 7
    }

}
